std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > Class Template Reference
Containers » Unordered Associative

`#include <unordered_map>`

## Public Types

using | node_type = typename _Hashtable::node_type
typedef _Hashtable::key_type | key_type
typedef _Hashtable::value_type | value_type
typedef _Hashtable::mapped_type | mapped_type
typedef _Hashtable::hasher | hasher
typedef _Hashtable::key_equal | key_equal
typedef _Hashtable::allocator_type | allocator_type
typedef _Hashtable::pointer | pointer
typedef _Hashtable::const_pointer | const_pointer
typedef _Hashtable::reference | reference
typedef _Hashtable::const_reference | const_reference
typedef _Hashtable::iterator | iterator
typedef _Hashtable::const_iterator | const_iterator
typedef _Hashtable::local_iterator | local_iterator
typedef _Hashtable::const_local_iterator | const_local_iterator
typedef _Hashtable::size_type | size_type
typedef _Hashtable::difference_type | difference_type

## Public Member Functions

| unordered_multimap ()=default
template<typename _InputIterator >
| unordered_multimap (_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type &__a)
template<typename _InputIterator >
| unordered_multimap (_InputIterator __first, _InputIterator __last, size_type __n, const hasher &__hf, const allocator_type &__a)
template<typename _InputIterator >
| unordered_multimap (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multimap (const allocator_type &__a)
| unordered_multimap (const unordered_multimap &)=default
| unordered_multimap (const unordered_multimap &__ummap, const allocator_type &__a)
| unordered_multimap (initializer_list< value_type > __l, size_type __n, const allocator_type &__a)
| unordered_multimap (initializer_list< value_type > __l, size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multimap (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multimap (size_type __n, const allocator_type &__a)
| unordered_multimap (size_type __n, const hasher &__hf, const allocator_type &__a)
| unordered_multimap (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multimap (unordered_multimap &&)=default
| unordered_multimap (unordered_multimap &&__ummap, const allocator_type &__a) noexcept(noexcept(_Hashtable(std::move(__ummap._M_h), __a)))
iterator | begin () noexcept
local_iterator | begin (size_type __n)
size_type | bucket (const key_type &__key) const
size_type | bucket_count () const noexcept
size_type | bucket_size (size_type __n) const
void | clear () noexcept
template<typename... _Args>
iterator | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
bool | empty () const noexcept
iterator | end () noexcept
local_iterator | end (size_type __n)
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
node_type | extract (const key_type &__key)
node_type | extract (const_iterator __pos)
allocator_type | get_allocator () const noexcept
hasher | hash_function () const
template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator __hint, node_type &&__nh)
void | insert (initializer_list< value_type > __l)
iterator | insert (node_type &&__nh)
key_equal | key_eq () const
float | load_factor () const noexcept
size_type | max_bucket_count () const noexcept
float | max_load_factor () const noexcept
void | max_load_factor (float __z)
size_type | max_size () const noexcept
template<typename _H2 , typename _P2 >
void | merge (unordered_map< _Key, _Tp, _H2, _P2, _Alloc > &&__source)
template<typename _H2 , typename _P2 >
void | merge (unordered_map< _Key, _Tp, _H2, _P2, _Alloc > &__source)
template<typename _H2 , typename _P2 >
void | merge (unordered_multimap< _Key, _Tp, _H2, _P2, _Alloc > &&__source)
template<typename _H2 , typename _P2 >
void | merge (unordered_multimap< _Key, _Tp, _H2, _P2, _Alloc > &__source)
unordered_multimap & | operator= (const unordered_multimap &)=default
unordered_multimap & | operator= (initializer_list< value_type > __l)
unordered_multimap & | operator= (unordered_multimap &&)=default
void | rehash (size_type __n)
void | reserve (size_type __n)
size_type | size () const noexcept
void | swap (unordered_multimap &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
const_iterator | begin () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | end () const noexcept
const_iterator | cend () const noexcept
iterator | insert (const value_type &__x)
iterator | insert (value_type &&__x)
template<typename _Pair >
__enable_if_t< is_constructible< value_type, _Pair && >::value, iterator > | insert (_Pair &&__x)
iterator | insert (const_iterator __hint, const value_type &__x)
iterator | insert (const_iterator __hint, value_type &&__x)
template<typename _Pair >
__enable_if_t< is_constructible< value_type, _Pair && >::value, iterator > | insert (const_iterator __hint, _Pair &&__x)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
iterator | find (const key_type &__x)
template<typename _Kt >
auto | find (const _Kt &__x) -> decltype(_M_h._M_find_tr(__x))
const_iterator | find (const key_type &__x) const
template<typename _Kt >
auto | find (const _Kt &__x) const -> decltype(_M_h._M_find_tr(__x))
size_type | count (const key_type &__x) const
template<typename _Kt >
auto | count (const _Kt &__x) const -> decltype(_M_h._M_count_tr(__x))
bool | contains (const key_type &__x) const
template<typename _Kt >
auto | contains (const _Kt &__x) const -> decltype(_M_h._M_find_tr(__x), void(), true)
std::pair< iterator, iterator > | equal_range (const key_type &__x)
template<typename _Kt >
auto | equal_range (const _Kt &__x) -> decltype(_M_h._M_equal_range_tr(__x))
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
template<typename _Kt >
auto | equal_range (const _Kt &__x) const -> decltype(_M_h._M_equal_range_tr(__x))
const_local_iterator | begin (size_type __n) const
const_local_iterator | cbegin (size_type __n) const
const_local_iterator | end (size_type __n) const
const_local_iterator | cend (size_type __n) const

## Friends

template<typename _Key1 , typename _Tp1 , typename _Hash1 , typename _Pred1 , typename _Alloc1 >
bool | operator== (const unordered_multimap< _Key1, _Tp1, _Hash1, _Pred1, _Alloc1 > &, const unordered_multimap< _Key1, _Tp1, _Hash1, _Pred1, _Alloc1 > &)
template<typename , typename , typename >
class | std::_Hash_merge_helper

## Detailed Description

template<typename _Key, typename _Tp, typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
class std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >

A standard container composed of equivalent keys (possibly containing multiple of each key value) that associates values of another type with the keys.

Since
  C++11

Template Parameters

  _Key | Type of key objects.
  _Tp | Type of mapped objects.
  _Hash | Hashing function object type, defaults to hash<_Value>.
  _Pred | Predicate function object type, defaults to equal_to<_Value>.
  _Alloc | Allocator type, defaults to std::allocator<std::pair<const _Key, _Tp>>.

Meets the requirements of a container, and unordered associative container

The resulting value type of the container is std::pair<const _Key, _Tp>.

Base is _Hashtable, dispatched at compile time via template alias __ummap_hashtable.

Definition at line 1254 of file unordered_map.h.

## Member Typedef Documentation

## allocator_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::allocator_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::allocator_type

Public typedefs.

Definition at line 1268 of file unordered_map.h.

## const_iterator

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::const_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 1278 of file unordered_map.h.

## const_local_iterator

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::const_local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::const_local_iterator

Iterator-related typedefs.

Definition at line 1280 of file unordered_map.h.

## const_pointer

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::const_pointer std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 1274 of file unordered_map.h.

## const_reference

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::const_reference std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 1276 of file unordered_map.h.

## difference_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::difference_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 1282 of file unordered_map.h.

## hasher

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::hasher std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::hasher

Public typedefs.

Definition at line 1266 of file unordered_map.h.

## iterator

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 1277 of file unordered_map.h.

## key_equal

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::key_equal std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::key_equal

Public typedefs.

Definition at line 1267 of file unordered_map.h.

## key_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::key_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 1263 of file unordered_map.h.

## local_iterator

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::local_iterator

Iterator-related typedefs.

Definition at line 1279 of file unordered_map.h.

## mapped_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::mapped_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::mapped_type

Public typedefs.

Definition at line 1265 of file unordered_map.h.

## node_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

using std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::node_type = typename _Hashtable::node_type

Definition at line 1286 of file unordered_map.h.

## pointer

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::pointer std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 1273 of file unordered_map.h.

## reference

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::reference std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::reference

Iterator-related typedefs.

Definition at line 1275 of file unordered_map.h.

## size_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 1281 of file unordered_map.h.

## value_type

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

typedef _Hashtable::value_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::value_type

Public typedefs.

Definition at line 1264 of file unordered_map.h.

## Constructor & Destructor Documentation

## unordered_multimap() [1/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( |  | ) |

default

Default constructor.

## unordered_multimap() [2/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | size_type | __n,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline explicit

Default constructor creates no elements.

Parameters

  __n | Mnimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Definition at line 1302 of file unordered_map.h.

## unordered_multimap() [3/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _InputIterator >

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds an unordered_multimap from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_multimap consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 1323 of file unordered_map.h.

## unordered_multimap() [4/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | const unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > & |  | ) |

default

Copy constructor.

## unordered_multimap() [5/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > && |  | ) |

default

Move constructor.

## unordered_multimap() [6/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | const allocator_type & | __a | ) |

inline explicit

Creates an unordered_multimap with no elements.

Parameters

  __a | An allocator object.

Definition at line 1342 of file unordered_map.h.

## unordered_multimap() [7/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | const unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > & | __ummap,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1351 of file unordered_map.h.

## unordered_multimap() [8/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > && | __ummap,
|  | const allocator_type & | __a
| ) |  |

inline noexcept

Definition at line 1361 of file unordered_map.h.

## unordered_multimap() [9/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | initializer_list< value_type > | __l,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds an unordered_multimap from an initializer_list.

Parameters

  __l | An initializer_list.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_multimap consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 1378 of file unordered_map.h.

## unordered_multimap() [10/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1386 of file unordered_map.h.

## unordered_multimap() [11/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1390 of file unordered_map.h.

## unordered_multimap() [12/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _InputIterator >

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1396 of file unordered_map.h.

## unordered_multimap() [13/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _InputIterator >

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1403 of file unordered_map.h.

## unordered_multimap() [14/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1409 of file unordered_map.h.

## unordered_multimap() [15/15]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::unordered_multimap | ( | initializer_list< value_type > | __l,
|  | size_type | __n,
|  | const hasher & | __hf,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 1415 of file unordered_map.h.

## Member Function Documentation

## begin() [1/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::begin | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multimap.

Definition at line 1485 of file unordered_map.h.

## begin() [2/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::begin | ( |  | ) |

inline noexcept

Returns a read/write iterator that points to the first element in the unordered_multimap.

Definition at line 1476 of file unordered_map.h.

## begin() [3/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) |

inline

Returns a read/write iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read/write local iterator.

Definition at line 1948 of file unordered_map.h.

## begin() [4/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1959 of file unordered_map.h.

## bucket()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::bucket | ( | const key_type & | __key | ) | const

inline

Definition at line 1938 of file unordered_map.h.

## bucket_count()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::bucket_count | ( |  | ) | const

inline noexcept

Returns the number of buckets of the unordered_multimap.

Definition at line 1915 of file unordered_map.h.

## bucket_size()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::bucket_size | ( | size_type | __n | ) | const

inline

Definition at line 1929 of file unordered_map.h.

## cbegin() [1/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::cbegin | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multimap.

Definition at line 1489 of file unordered_map.h.

## cbegin() [2/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::cbegin | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1963 of file unordered_map.h.

## cend() [1/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::cend | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multimap.

Definition at line 1511 of file unordered_map.h.

Referenced by std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert().

## cend() [2/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::cend | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1989 of file unordered_map.h.

## clear()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::clear | ( |  | ) |

inline noexcept

Erases all elements in an unordered_multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1740 of file unordered_map.h.

## contains() [1/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Kt >

auto std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::contains | ( | const _Kt & | __x | ) | const -> decltype(_M_h._M_find_tr(__x), void(), true)

inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 1873 of file unordered_map.h.

## contains() [2/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

bool std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::contains | ( | const key_type & | __x | ) | const

inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of elements to be located.

Returns
  True if there is any element with the specified key.

Definition at line 1868 of file unordered_map.h.

## count() [1/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Kt >

auto std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::count | ( | const _Kt & | __x | ) | const -> decltype(_M_h._M_count_tr(__x))

inline

Finds the number of elements.

Parameters

  __x | Key to count.

Returns
  Number of elements with specified key.

Definition at line 1855 of file unordered_map.h.

## count() [2/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::count | ( | const key_type & | __x | ) | const

inline

Finds the number of elements.

Parameters

  __x | Key to count.

Returns
  Number of elements with specified key.

Definition at line 1849 of file unordered_map.h.

## emplace()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename... _Args>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::emplace | ( | _Args &&... | __args | ) |

inline

Attempts to build and insert a std::pair into the unordered_multimap.

Parameters

  __args | Arguments used to generate a new pair instance (see std::piecewise_contruct for passing arguments to each part of the pair constructor).

Returns
  An iterator that points to the inserted pair.

This function attempts to build and insert a (key, value) pair into the unordered_multimap.

Insertion requires amortized constant time.

Definition at line 1534 of file unordered_map.h.

## emplace_hint()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename... _Args>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args
| ) |  |

inline

Attempts to build and insert a std::pair into the unordered_multimap.

Parameters

  __pos | An iterator that serves as a hint as to where the pair should be inserted.
  __args | Arguments used to generate a new pair instance (see std::piecewise_contruct for passing arguments to each part of the pair constructor).

Returns
  An iterator that points to the element with key of the std::pair built from __args.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires amortized constant time.

Definition at line 1561 of file unordered_map.h.

## empty()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

bool std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::empty | ( |  | ) | const

inline noexcept

Returns true if the unordered_multimap is empty.

Definition at line 1456 of file unordered_map.h.

## end() [1/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::end | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multimap.

Definition at line 1507 of file unordered_map.h.

## end() [2/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::end | ( |  | ) |

inline noexcept

Returns a read/write iterator that points one past the last element in the unordered_multimap.

Definition at line 1498 of file unordered_map.h.

Referenced by std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::extract().

## end() [3/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) |

inline

Returns a read/write iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read/write local iterator.

Definition at line 1974 of file unordered_map.h.

## end() [4/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_local_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1985 of file unordered_map.h.

## equal_range() [1/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Kt >

auto std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::equal_range | ( | const _Kt & | __x | ) | -> decltype(_M_h._M_equal_range_tr(__x))

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1893 of file unordered_map.h.

## equal_range() [2/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Kt >

auto std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::equal_range | ( | const _Kt & | __x | ) | const -> decltype(_M_h._M_equal_range_tr(__x))

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1905 of file unordered_map.h.

## equal_range() [3/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::pair< iterator, iterator > std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) |

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1887 of file unordered_map.h.

## equal_range() [4/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

std::pair< const_iterator, const_iterator > std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) | const

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1899 of file unordered_map.h.

## erase() [1/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::erase | ( | const key_type & | __x | ) |

inline

Erases elements according to the provided key.

Parameters

  __x | Key of elements to be erased.

Returns
  The number of elements erased.

This function erases all the elements located by the given key from an unordered_multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1711 of file unordered_map.h.

## erase() [2/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last
| ) |  |

inline

Erases a [__first,__last) range of elements from an unordered_multimap.

Parameters

  __first | Iterator pointing to the start of the range to be erased.
  __last | Iterator pointing to the end of the range to be erased.

Returns
  The iterator __last.

This function erases a sequence of elements from an unordered_multimap. Note that this function only erases the elements, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1730 of file unordered_map.h.

## erase() [3/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __position | ) |

inline

Erases an element from an unordered_multimap.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1690 of file unordered_map.h.

## erase() [4/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::erase | ( | iterator | __position | ) |

inline

Erases an element from an unordered_multimap.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1695 of file unordered_map.h.

## extract() [1/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

node_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::extract | ( | const key_type & | __key | ) |

inline

Extract a node.

Definition at line 1661 of file unordered_map.h.

## extract() [2/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

node_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::extract | ( | const_iterator | __pos | ) |

inline

Extract a node.

Definition at line 1653 of file unordered_map.h.

References std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::end().

## find() [1/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Kt >

auto std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::find | ( | const _Kt & | __x | ) | -> decltype(_M_h._M_find_tr(__x))

inline

Tries to locate an element in an unordered_multimap.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1826 of file unordered_map.h.

## find() [2/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Kt >

auto std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::find | ( | const _Kt & | __x | ) | const -> decltype(_M_h._M_find_tr(__x))

inline

Tries to locate an element in an unordered_multimap.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1837 of file unordered_map.h.

## find() [3/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) |

inline

Tries to locate an element in an unordered_multimap.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1820 of file unordered_map.h.

## find() [4/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

const_iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) | const

inline

Tries to locate an element in an unordered_multimap.

Parameters

  __x | Key to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1831 of file unordered_map.h.

## get_allocator()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

allocator_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::get_allocator | ( |  | ) | const

inline noexcept

Returns the allocator object used by the unordered_multimap.

Definition at line 1449 of file unordered_map.h.

## hash_function()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

hasher std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::hash_function | ( |  | ) | const

inline

Returns the hash functor object with which the unordered_multimap was constructed.

Definition at line 1796 of file unordered_map.h.

## insert() [1/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _InputIterator >

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

A template function that attempts to insert a range of elements.

Parameters

  __first | Iterator pointing to the start of the range to be inserted.
  __last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 1635 of file unordered_map.h.

## insert() [2/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Pair >

__enable_if_t< is_constructible< value_type, _Pair && >::value, iterator > std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | _Pair && | __x | ) |

inline

Inserts a std::pair into the unordered_multimap.

Parameters

  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the inserted pair.

Insertion requires amortized constant time.

Definition at line 1584 of file unordered_map.h.

## insert() [3/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | const value_type & | __x | ) |

inline

Inserts a std::pair into the unordered_multimap.

Parameters

  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the inserted pair.

Insertion requires amortized constant time.

Definition at line 1575 of file unordered_map.h.

## insert() [4/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _Pair >

__enable_if_t< is_constructible< value_type, _Pair && >::value, iterator > std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | _Pair && | __x
| ) |  |

inline

Inserts a std::pair into the unordered_multimap.

Parameters

  __hint | An iterator that serves as a hint as to where the pair should be inserted.
  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the element with key of __x (may or may not be the pair passed in).

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires amortized constant time.

Definition at line 1620 of file unordered_map.h.

## insert() [5/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | const value_type & | __x
| ) |  |

inline

Inserts a std::pair into the unordered_multimap.

Parameters

  __hint | An iterator that serves as a hint as to where the pair should be inserted.
  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the element with key of __x (may or may not be the pair passed in).

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires amortized constant time.

Definition at line 1609 of file unordered_map.h.

## insert() [6/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | node_type && | __nh
| ) |  |

inline

Re-insert an extracted node.

Definition at line 1671 of file unordered_map.h.

References std::move().

## insert() [7/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | value_type && | __x
| ) |  |

inline

Inserts a std::pair into the unordered_multimap.

Parameters

  __hint | An iterator that serves as a hint as to where the pair should be inserted.
  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the element with key of __x (may or may not be the pair passed in).

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires amortized constant time.

Definition at line 1615 of file unordered_map.h.

References std::move().

## insert() [8/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | initializer_list< value_type > | __l | ) |

inline

Attempts to insert a list of elements into the unordered_multimap.

Parameters

  __l | A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 1647 of file unordered_map.h.

## insert() [9/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | node_type && | __nh | ) |

inline

Re-insert an extracted node.

Definition at line 1666 of file unordered_map.h.

References std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::cend(), and std::move().

## insert() [10/10]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

iterator std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert | ( | value_type && | __x | ) |

inline

Inserts a std::pair into the unordered_multimap.

Parameters

  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the inserted pair.

Insertion requires amortized constant time.

Definition at line 1579 of file unordered_map.h.

References std::move().

## key_eq()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

key_equal std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::key_eq | ( |  | ) | const

inline

Returns the key comparison object with which the unordered_multimap was constructed.

Definition at line 1802 of file unordered_map.h.

## load_factor()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

float std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::load_factor | ( |  | ) | const

inline noexcept

Returns the average number of elements per bucket.

Definition at line 1997 of file unordered_map.h.

## max_bucket_count()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::max_bucket_count | ( |  | ) | const

inline noexcept

Returns the maximum number of buckets of the unordered_multimap.

Definition at line 1920 of file unordered_map.h.

## max_load_factor() [1/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

float std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::max_load_factor | ( |  | ) | const

inline noexcept

Returns a positive number that the unordered_multimap tries to keep the load factor less than or equal to.

Definition at line 2003 of file unordered_map.h.

## max_load_factor() [2/2]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::max_load_factor | ( | float | __z | ) |

inline

Change the unordered_multimap maximum load factor.

Parameters

  __z | The new maximum load factor.

Definition at line 2011 of file unordered_map.h.

## max_size()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::max_size | ( |  | ) | const

inline noexcept

Returns the maximum size of the unordered_multimap.

Definition at line 1466 of file unordered_map.h.

## merge() [1/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _H2 , typename _P2 >

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::merge | ( | unordered_map< _Key, _Tp, _H2, _P2, _Alloc > && | __source | ) |

inline

Definition at line 1787 of file unordered_map.h.

## merge() [2/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _H2 , typename _P2 >

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::merge | ( | unordered_map< _Key, _Tp, _H2, _P2, _Alloc > & | __source | ) |

inline

Definition at line 1778 of file unordered_map.h.

## merge() [3/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _H2 , typename _P2 >

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::merge | ( | unordered_multimap< _Key, _Tp, _H2, _P2, _Alloc > && | __source | ) |

inline

Definition at line 1773 of file unordered_map.h.

## merge() [4/4]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename _H2 , typename _P2 >

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::merge | ( | unordered_multimap< _Key, _Tp, _H2, _P2, _Alloc > & | __source | ) |

inline

Definition at line 1764 of file unordered_map.h.

## operator=() [1/3]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

unordered_multimap & std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::operator= | ( | const unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > & |  | ) |

default

Copy assignment operator.

## operator=() [2/3]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

unordered_multimap & std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |

inline

Unordered_multimap list assignment operator.

Parameters

  __l | An initializer_list.

This function fills an unordered_multimap with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_multimap and that the resulting unordered_multimap's size is the same as the number of elements assigned.

Definition at line 1441 of file unordered_map.h.

## operator=() [3/3]

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

unordered_multimap & std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::operator= | ( | unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > && |  | ) |

default

Move assignment operator.

## rehash()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::rehash | ( | size_type | __n | ) |

inline

May rehash the unordered_multimap.

Parameters

  __n | The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_multimap maximum load factor.

Definition at line 2022 of file unordered_map.h.

## reserve()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::reserve | ( | size_type | __n | ) |

inline

Prepare the unordered_multimap for a specified number of elements.

Parameters

  __n | Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 2033 of file unordered_map.h.

## size()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

size_type std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::size | ( |  | ) | const

inline noexcept

Returns the size of the unordered_multimap.

Definition at line 1461 of file unordered_map.h.

## swap()

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>

void std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::swap | ( | unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc > & | __x | ) |

inline noexcept

Swaps data with another unordered_multimap.

Parameters

  __x | An unordered_multimap of the same element and allocator types.

This exchanges the elements between two unordered_multimap in constant time. Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 1754 of file unordered_map.h.

## Friends And Related Symbol Documentation

## std::_Hash_merge_helper

template<typename _Key , typename _Tp , typename _Hash = hash<_Key>, typename _Pred = equal_to<_Key>, typename _Alloc = allocator<std::pair<const _Key, _Tp>>>
template<typename , typename , typename >

friend class std::_Hash_merge_helper

friend

Definition at line 1760 of file unordered_map.h.

The documentation for this class was generated from the following file:

- unordered_map.h